"use strict";
function init(d) {
    root = d;
    return root;
}
exports.init = init;
var root = {};
function addFile(r) {
    var type = r.type, name = r.name, url = r.url;
    if (!type)
        type = "";
    name = normalize(name);
    var basefilename = basename(name);
    var folder = dirname(name);
    if (!exists(folder)) {
        mkdir(folder);
    }
    var d = reslove(folder);
    if (d) {
        d[basefilename] = { url: url, type: type, name: name };
    }
}
exports.addFile = addFile;
function getFile(filename) {
    return reslove(filename);
}
exports.getFile = getFile;
function basename(filename) {
    return filename.substr(filename.lastIndexOf("/") + 1);
}
function normalize(filename) {
    return filename.split("/").filter(function (d) { return !!d; }).join("/");
}
function dirname(path) {
    return path.substr(0, path.lastIndexOf("/"));
}
function reslove(dirpath) {
    if (dirpath == "") {
        return root;
    }
    dirpath = normalize(dirpath);
    var list = dirpath.split("/");
    var current = root;
    for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
        var f = list_1[_i];
        current = current[f];
        if (!current) {
            return null;
        }
    }
    return current;
}
function mkdir(dirpath) {
    dirpath = normalize(dirpath);
    var list = dirpath.split("/");
    var current = root;
    for (var _i = 0, list_2 = list; _i < list_2.length; _i++) {
        var f = list_2[_i];
        if (!current[f]) {
            current[f] = {};
        }
        current = current[f];
    }
}
exports.mkdir = mkdir;
function exists(dirpath) {
    if (dirpath == "")
        return true;
    dirpath = normalize(dirpath);
    var list = dirpath.split("/");
    var current = root;
    for (var _i = 0, list_3 = list; _i < list_3.length; _i++) {
        var f = list_3[_i];
        if (!current[f]) {
            return false;
        }
        current = current[f];
    }
    return true;
}
exports.exists = exists;
