"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var vinylfs = require("vinyl-fs");
var _1 = require("./");
var utils = require("egret-node-utils");
var fs = require("fs-extra-promise");
var path = require("path");
var merger = require("./merger");
var html = require("./html");
var config = require("./config");
var map = require('map-stream');
var crc32 = require("crc32");
var projectRoot;
var resourceFolder;
function build(p, format, publishPath, debug) {
    if (debug === void 0) { debug = false; }
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var resourcePath, _a, _b, _c, _d, result, executeFilter, option, init, convert, convert2, list, outputFile, stream;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!publishPath) return [3 /*break*/, 2];
                    _c = (_b = path).join;
                    _d = [publishPath];
                    return [4 /*yield*/, config.getConfigViaDecorator(p)];
                case 1:
                    _a = _c.apply(_b, _d.concat([(_e.sent()).resourceRoot]));
                    return [3 /*break*/, 3];
                case 2:
                    _a = undefined;
                    _e.label = 3;
                case 3:
                    resourcePath = _a;
                    return [4 /*yield*/, _1.ResourceConfig.init(p)];
                case 4:
                    result = _e.sent();
                    _1.ResourceConfig.typeSelector = result.typeSelector;
                    _1.ResourceConfig.nameSelector = result.nameSelector;
                    executeFilter = function (url) { return __awaiter(_this, void 0, void 0, function () {
                        var ext, type, name;
                        return __generator(this, function (_a) {
                            ext = url.substr(url.lastIndexOf(".") + 1);
                            merger.walk(url);
                            type = _1.ResourceConfig.typeSelector(url);
                            name = _1.ResourceConfig.nameSelector(url);
                            if (type) {
                                return [2 /*return*/, { name: name, url: url, type: type }];
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                        });
                    }); };
                    projectRoot = p;
                    resourceFolder = path.join(projectRoot, result.resourceRoot);
                    merger.init(resourceFolder);
                    option = {
                        relative: true,
                        ignoreHiddenFile: true
                    };
                    init = function (file, cb) {
                        file.original_relative = file.relative.split("\\").join("/");
                        cb(null, file);
                    };
                    convert = function (file, cb) {
                        var crc32_file_path = crc32(file.contents);
                        crc32_file_path = crc32_file_path.substr(0, 2) + "/" + crc32_file_path.substr(2) + file.extname;
                        file.path = "" + file.base + crc32_file_path;
                        cb(null, file);
                    };
                    convert2 = function (file, cb) { return __awaiter(_this, void 0, void 0, function () {
                        var r;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, executeFilter(file.original_relative)];
                                case 1:
                                    r = _a.sent();
                                    if (r) {
                                        r.url = file.relative;
                                        _1.ResourceConfig.addFile(r, true);
                                        cb(null, file);
                                    }
                                    else {
                                        cb(null);
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    }); };
                    return [4 /*yield*/, utils.walk(resourceFolder, function () { return true; }, option)];
                case 5:
                    list = _e.sent();
                    outputFile = resourcePath ?
                        path.join(resourcePath, result.resourceConfigFileName) :
                        path.join(resourceFolder, result.resourceConfigFileName);
                    stream = vinylfs.src("**/**.*", { cwd: resourceFolder, base: resourceFolder })
                        .pipe(map(init));
                    if (resourcePath) {
                        stream = stream.pipe(map(convert));
                    }
                    stream = stream.pipe(map(convert2).on("end", function () { return __awaiter(_this, void 0, void 0, function () {
                        var config;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    config = _1.ResourceConfig.getConfig();
                                    return [4 /*yield*/, convertResourceJson(projectRoot, config)];
                                case 1:
                                    _a.sent();
                                    return [4 /*yield*/, updateResourceConfigFileContent(outputFile, debug)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, _1.ResourceConfig.generateClassicalConfig(path.join(resourceFolder, "wing.res.json"))];
                                case 3:
                                    _a.sent();
                                    merger.output();
                                    return [2 /*return*/];
                            }
                        });
                    }); }));
                    if (resourcePath) {
                        stream = stream.pipe(vinylfs.dest(resourcePath).on("end", function () {
                            html.publish(publishPath, outputFile).catch(function (e) { return _1.handleException(e); });
                        }));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.build = build;
function updateResourceConfigFileContent(filename, debug) {
    return __awaiter(this, void 0, void 0, function () {
        var config, content;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = _1.ResourceConfig.generateConfig(debug);
                    content = JSON.stringify(config, null, "\t");
                    return [4 /*yield*/, fs.mkdirpAsync(path.dirname(filename))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, fs.writeFileAsync(filename, content, "utf-8")];
                case 2:
                    _a.sent();
                    return [2 /*return*/, content];
            }
        });
    });
}
exports.updateResourceConfigFileContent = updateResourceConfigFileContent;
function convertResourceJson(projectRoot, config) {
    return __awaiter(this, void 0, void 0, function () {
        var filename, resourceJson, _i, _a, r, resourceName, file, resource_custom_key, subkeysArr, _b, subkeysArr_1, subkey, _c, _d, group;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    filename = path.join(projectRoot, "resource/default.res.json");
                    if (!fs.existsSync(filename)) {
                        filename = path.join(projectRoot, "resource/resource.json");
                    }
                    if (!fs.existsSync(filename)) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, fs.readJSONAsync(filename)];
                case 1:
                    resourceJson = _e.sent();
                    _i = 0, _a = resourceJson.resources;
                    _e.label = 2;
                case 2:
                    if (!(_i < _a.length)) return [3 /*break*/, 6];
                    r = _a[_i];
                    resourceName = _1.ResourceConfig.nameSelector(r.url);
                    file = _1.ResourceConfig.getFile(resourceName);
                    if (!!file) return [3 /*break*/, 4];
                    return [4 /*yield*/, fs.existsAsync(path.join(resourceFolder, r.url))];
                case 3:
                    if (_e.sent()) {
                        _1.ResourceConfig.addFile(r, false);
                    }
                    else {
                        console.error("missing file " + r.name + " " + r.url);
                    }
                    return [3 /*break*/, 5];
                case 4:
                    if (file.name != r.name) {
                        config.alias[r.name] = file.name;
                    }
                    for (resource_custom_key in r) {
                        if (resource_custom_key == "url" || resource_custom_key == "name") {
                            continue;
                        }
                        else if (resource_custom_key == "subkeys") {
                            subkeysArr = r[resource_custom_key].split(",");
                            for (_b = 0, subkeysArr_1 = subkeysArr; _b < subkeysArr_1.length; _b++) {
                                subkey = subkeysArr_1[_b];
                                // if (!obj.alias[subkeysArr[i]]) {
                                config.alias[subkey] = r.name + "#" + subkey;
                                file[resource_custom_key] = r[resource_custom_key];
                            }
                        }
                        else {
                            // 包含 type 在内的自定义属性
                            file[resource_custom_key] = r[resource_custom_key];
                        }
                    }
                    _e.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 2];
                case 6:
                    for (_c = 0, _d = resourceJson.groups; _c < _d.length; _c++) {
                        group = _d[_c];
                        config.groups[group.name] = group.keys.split(",");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.convertResourceJson = convertResourceJson;
