import { Data } from './index';
import * as vfs from './FileSystem';
export * from './watch';
export * from './config';
export * from './upgrade';
export * from './build';
export * from './version';
export * from './html';
export declare let handleException: (e: string | Error) => void;
export interface Data {
    resources: vfs.Dictionary;
    groups: {
        [groupName: string]: string[];
    };
    alias: {
        [aliasName: string]: string;
    };
}
export interface GeneratedDictionary {
    [file: string]: GeneratedFile | GeneratedDictionary;
}
export declare type GeneratedFile = string | vfs.File;
export interface GeneratedData {
    resources: GeneratedDictionary;
    groups: {
        [groupName: string]: string[];
    };
    alias: {
        [aliasName: string]: string;
    };
}
export declare namespace original {
    interface Info {
        groups: GroupInfo[];
        resources: ResourceInfo[];
    }
    interface GroupInfo {
        keys: string;
        name: string;
    }
    interface ResourceInfo {
        name: string;
        type: string;
        url: string;
        subkeys?: string;
    }
}
export declare namespace ResourceConfig {
    function getConfig(): Data;
    function generateClassicalConfig(filename: string): Promise<void>;
    function generateConfig(debug: boolean): GeneratedData;
    var typeSelector: (path: string) => string;
    var nameSelector: (path: string) => string;
    var mergeSelector: (path: string) => {
        path: string;
        alias: string;
    } | null;
    function addFile(r: vfs.File, checkDuplicate: boolean): void;
    function getFile(filename: string): vfs.File | undefined;
    function init(projectPath: any): Promise<{
        resourceRoot: string;
        resourceConfigFileName: any;
        typeSelector: (p: string) => string;
        mergeSelector: any;
        nameSelector: (p: string) => string;
    }>;
}
