"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var path = require("path");
var fs = require("fs-extra-promise");
var vfs = require("./FileSystem");
var _config = require("./config");
__export(require("./watch"));
__export(require("./config"));
__export(require("./upgrade"));
__export(require("./build"));
__export(require("./version"));
__export(require("./html"));
exports.handleException = function (e) {
    if (typeof e == 'string') {
        console.log("\u9519\u8BEF:" + e);
    }
    else {
        console.log("\u9519\u8BEF:" + e.stack);
    }
};
var ResourceNodeType;
(function (ResourceNodeType) {
    ResourceNodeType[ResourceNodeType["FILE"] = 0] = "FILE";
    ResourceNodeType[ResourceNodeType["DICTIONARY"] = 1] = "DICTIONARY";
})(ResourceNodeType || (ResourceNodeType = {}));
var ResourceConfig;
(function (ResourceConfig) {
    function loop(r, callback) {
        for (var key in r) {
            var f = r[key];
            if (isFile(f)) {
                callback(f);
            }
            else {
                loop(f, callback);
            }
        }
    }
    function isFile(r) {
        return r.url;
    }
    function getConfig() {
        return config;
    }
    ResourceConfig.getConfig = getConfig;
    function generateClassicalConfig(filename) {
        return __awaiter(this, void 0, void 0, function () {
            var result, resources, alias, aliasName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = {
                            groups: [],
                            resources: []
                        };
                        resources = config.resources;
                        alias = {};
                        for (aliasName in config.alias) {
                            alias[config.alias[aliasName]] = aliasName;
                        }
                        loop(resources, function (f) {
                            var r = f;
                            if (alias[r.name]) {
                                r.name = alias[r.name];
                            }
                            result.resources.push(r);
                            // console.log(f.name)
                        });
                        return [4 /*yield*/, fs.writeJSONAsync(filename, result)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    ResourceConfig.generateClassicalConfig = generateClassicalConfig;
    function generateConfig(debug) {
        var loop = function (r) {
            for (var key in r) {
                var f = r[key];
                if (isFile(f)) {
                    if (typeof (f) == "string") {
                        continue;
                    }
                    if (!debug) {
                        delete f.name;
                        // console.log 
                        if (ResourceConfig.typeSelector(f.url) == f.type) {
                            delete f.type;
                        }
                        if (Object.keys(f).length == 1) {
                            r[key] = f.url;
                        }
                    }
                }
                else {
                    loop(f);
                }
            }
        };
        var isFile = function (r) {
            if (r['url']) {
                return true;
            }
            else {
                return false;
            }
        };
        var generatedData = JSON.parse(JSON.stringify(config.resources));
        loop(generatedData);
        var result = {
            alias: config.alias,
            groups: config.groups,
            resources: generatedData
        };
        return result;
    }
    ResourceConfig.generateConfig = generateConfig;
    var config;
    var resourcePath;
    function addFile(r, checkDuplicate) {
        var url = r.url, name = r.name;
        url = url.split("\\").join("/");
        name = name.split("\\").join("/");
        r.url = url;
        r.name = name;
        if (checkDuplicate) {
            var a = vfs.getFile(r.name);
            if (a && a.url != r.url) {
                console.warn("duplicate: " + r.url + " => " + a.url);
            }
        }
        vfs.addFile(r);
    }
    ResourceConfig.addFile = addFile;
    function getFile(filename) {
        return vfs.getFile(filename);
    }
    ResourceConfig.getFile = getFile;
    function init(projectPath) {
        return __awaiter(this, void 0, void 0, function () {
            var result, filename;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _config.getConfigViaDecorator(projectPath)];
                    case 1:
                        result = _a.sent();
                        ResourceConfig.typeSelector = result.typeSelector;
                        ResourceConfig.mergeSelector = result.mergeSelector;
                        resourcePath = path.resolve(projectPath, result.resourceRoot);
                        filename = path.resolve(process.cwd(), projectPath, result.resourceRoot, result.resourceConfigFileName);
                        ;
                        config = { alias: {}, groups: {}, resources: {} };
                        vfs.init(config.resources);
                        return [2 /*return*/, result];
                }
            });
        });
    }
    ResourceConfig.init = init;
})(ResourceConfig = exports.ResourceConfig || (exports.ResourceConfig = {}));
