"use strict";
var _1 = require("./");
var fs = require("fs-extra-promise");
var path = require("path");
var resourcePath;
var mergeCollection = {};
function init(p) {
    resourcePath = p;
}
exports.init = init;
function walk(f) {
    if (_1.ResourceConfig.mergeSelector) {
        var merge = _1.ResourceConfig.mergeSelector(f);
        if (merge) {
            var mergeFile = merge.path;
            merge.path = f;
            var type = _1.ResourceConfig.typeSelector(f);
            if (!type) {
                throw new Error("missing merge type : " + merge.path);
            }
            if (!mergeCollection[mergeFile]) {
                mergeCollection[mergeFile] = [];
            }
            mergeCollection[mergeFile].push(merge);
        }
    }
}
exports.walk = walk;
function output() {
    var _loop_1 = function (mergeFile) {
        var outputJson = {};
        var sourceFiles = mergeCollection[mergeFile];
        if (_1.ResourceConfig.typeSelector(mergeFile) == "mergeJson") {
            sourceFiles.map(function (s) {
                var sourcePath = path.join(resourcePath, s.path);
                var json = fs.readJSONSync(sourcePath);
                outputJson[s.alias] = json;
            });
        }
        fs.writeFileSync(path.join(resourcePath, mergeFile), JSON.stringify(outputJson));
    };
    for (var mergeFile in mergeCollection) {
        _loop_1(mergeFile);
    }
}
exports.output = output;
