"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var path = require("path");
var fs = require("fs-extra-promise");
var config = require("./config");
function upgrade(projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        function copyLibrary() {
            return __awaiter(this, void 0, void 0, function () {
                var propertyFile, propertyData, version, _i, _a, m, source, target, _b, _c, m;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            propertyFile = path.join(projectPath, "egretProperties.json");
                            return [4 /*yield*/, fs.readJsonAsync(propertyFile)];
                        case 1:
                            propertyData = _d.sent();
                            version = generateVersion(propertyData.egret_version);
                            delete propertyData.modules['res'];
                            for (_i = 0, _a = propertyData.modules; _i < _a.length; _i++) {
                                m = _a[_i];
                                if (m.name == "res") {
                                    m.name = "resourcemanager";
                                    m.path = ".";
                                }
                            }
                            source = config.getDist().folder;
                            target = path.join(projectPath, "bin/resourcemanager");
                            if (version >= 4000100) {
                                for (_b = 0, _c = propertyData.modules; _b < _c.length; _b++) {
                                    m = _c[_b];
                                    if (m.name == "resourcemanager") {
                                        m.path = "resourcemanager";
                                    }
                                }
                                target = path.join(projectPath, "resourcemanager");
                            }
                            return [4 /*yield*/, fs.writeJSONAsync(propertyFile, propertyData)];
                        case 2:
                            _d.sent();
                            return [4 /*yield*/, fs.copyAsync(source, target)];
                        case 3:
                            _d.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
        function createDecorator() {
            return __awaiter(this, void 0, void 0, function () {
                var mainSourceFile, contents, index;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            mainSourceFile = path.join(projectPath, "src/Main.ts");
                            return [4 /*yield*/, fs.readFileAsync(mainSourceFile, "utf-8")];
                        case 1:
                            contents = _a.sent();
                            if (contents.indexOf("RES.mapConfig") == -1) {
                                index = contents.indexOf("class Main");
                                if (index == -1) {
                                    throw new Error("无法匹配到 class Main,升级失败");
                                }
                                contents = contents.substr(0, index) + "\n// \u8D44\u6E90\u914D\u7F6E\uFF0C\u60A8\u53EF\u4EE5\u8BBF\u95EE\n// https://github.com/egret-labs/resourcemanager/tree/master/docs\n// \u4E86\u89E3\u66F4\u591A\u7EC6\u8282 \n@RES.mapConfig(\"config.json\",()=>\"resource\",path => {\n    var ext = path.substr(path.lastIndexOf(\".\") + 1);\n    var typeMap = {\n        \"jpg\": \"image\",\n        \"png\": \"image\",\n        \"webp\": \"image\",\n        \"json\": \"json\",\n        \"fnt\": \"font\",\n        \"pvr\": \"pvr\",\n        \"mp3\": \"sound\"\n    }\n    var type = typeMap[ext];\n    if (type == \"json\") {\n        if (path.indexOf(\"sheet\") >= 0) {\n            type = \"sheet\";\n        } else if (path.indexOf(\"movieclip\") >= 0) {\n            type = \"movieclip\";\n        };\n    }\n    return type;\n})\n"
                                    + contents.substr(index);
                            }
                            return [4 /*yield*/, fs.writeFileAsync(mainSourceFile, contents, "utf-8")];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
        function modifyTypeScriptConfigFile() {
            return __awaiter(this, void 0, void 0, function () {
                var tsconfigFile, contents, tsconfigJson;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            tsconfigFile = path.join(projectPath, "tsconfig.json");
                            return [4 /*yield*/, fs.existsAsync(tsconfigFile)];
                        case 1:
                            if (!!(_a.sent())) return [3 /*break*/, 3];
                            contents = "{\n   \"compilerOptions\": {\n      \"target\": \"es5\",\n      \"experimentalDecorators\":true\n   },\n   \"exclude\": [\n      \"node_modules\"\n   ]\n}";
                            return [4 /*yield*/, fs.writeFileAsync(tsconfigFile, contents, 'utf-8')];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, fs.readJSONAsync(tsconfigFile)];
                        case 4:
                            tsconfigJson = _a.sent();
                            tsconfigJson.compilerOptions.experimentalDecorators = true;
                            return [4 /*yield*/, fs.writeFileAsync(tsconfigFile, JSON.stringify(tsconfigJson, null, "\t"), 'utf-8')];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        }
        var generateVersion;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    generateVersion = function (versionString) {
                        var v = versionString.split(".");
                        var result = 0;
                        for (var i = 0; i < v.length; i++) {
                            result += parseInt(v[i]) * Math.pow(100, (3 - i));
                        }
                        return result;
                    };
                    ;
                    return [4 /*yield*/, copyLibrary()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, createDecorator()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, modifyTypeScriptConfigFile()];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.upgrade = upgrade;
